AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException Event

Definition

Tritt auf, wenn eine Ausnahme nicht abgefangen wird.Occurs when an exception is not caught.

public:
 virtual event UnhandledExceptionEventHandler ^ UnhandledException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event UnhandledExceptionEventHandler UnhandledException;
member this.UnhandledException : UnhandledExceptionEventHandler 
Public Custom Event UnhandledException As UnhandledExceptionEventHandler 

Implementiert

Attribute

Beispiele

Das folgende Beispiel zeigt die UnhandledException Ereignis.The following example demonstrates the UnhandledException event. Definiert einen Ereignishandler MyHandler, die aufgerufen wird, wenn eine nicht behandelte Ausnahme, in der Standardanwendungsdomäne ausgelöst wird.It defines an event handler, MyHandler, that is invoked whenever an unhandled exception is thrown in the default application domain. Klicken Sie dann zwei Ausnahmen ausgelöst.It then throws two exceptions. Die erste erfolgt durch eine Try/Catch- Block.The first is handled by a try/catch block. Die zweite wird nicht behandelt, und ruft die MyHandle Routine, bevor die Anwendung beendet wird.The second is unhandled and invokes the MyHandle routine before the application terminates.

// The example should be compiled with the /clr:pure compiler option.
using namespace System;
using namespace System::Security::Permissions;

public ref class Example
{


private:
   static void MyHandler(Object^ sender, UnhandledExceptionEventArgs^ args)
   {
      Exception^ e = dynamic_cast<Exception^>(args->ExceptionObject);
      Console::WriteLine( "MyHandler caught : {0}", e->Message );
      Console::WriteLine("Runtime terminating: {0}", args->IsTerminating);
   }
   
public: 
   [SecurityPermissionAttribute( SecurityAction::Demand, ControlAppDomain = true )]
   static void Main()
   {
      AppDomain^ currentDomain = AppDomain::CurrentDomain;
      currentDomain->UnhandledException += gcnew UnhandledExceptionEventHandler(Example::MyHandler);
      try
      {
         throw gcnew Exception("1");
      }
      catch (Exception^ e) 
      {
         Console::WriteLine( "Catch clause caught : {0}\n", e->Message );
      }

      throw gcnew Exception("2");
   }
};

void main()
{
   Example::Main();
}   
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()
//          at mainCRTStartup(String[] arguments)
using System;
using System.Security.Permissions;

public class Example 
{
   [SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
   public static void Main()
   {
      AppDomain currentDomain = AppDomain.CurrentDomain;
      currentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyHandler);
      
      try {
         throw new Exception("1");
      } catch (Exception e) {
         Console.WriteLine("Catch clause caught : {0} \n", e.Message);
      }

      throw new Exception("2");
   }
   
   static void MyHandler(object sender, UnhandledExceptionEventArgs args) 
   {
      Exception e = (Exception) args.ExceptionObject;
      Console.WriteLine("MyHandler caught : " + e.Message);
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating);
   }
}
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()  
Module Example
   Sub Main()
      Dim currentDomain As AppDomain = AppDomain.CurrentDomain
      AddHandler currentDomain.UnhandledException, AddressOf MyHandler
      
      Try
         Throw New Exception("1")
      Catch e As Exception
         Console.WriteLine("Catch clause caught : " + e.Message)
         Console.WriteLine()
      End Try
      
      Throw New Exception("2")
   End Sub
   
   Sub MyHandler(sender As Object, args As UnhandledExceptionEventArgs)
      Dim e As Exception = DirectCast(args.ExceptionObject, Exception)
      Console.WriteLine("MyHandler caught : " + e.Message)
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating)
   End Sub
End Module
' The example displays the following output:
'       Catch clause caught : 1
'       
'       MyHandler caught : 2
'       Runtime terminating: True
'       
'       Unhandled Exception: System.Exception: 2
'          at Example.Main()

Hinweise

Dieses Ereignis stellt eine Benachrichtigung nicht abgefangenen Ausnahmen bereit.This event provides notification of uncaught exceptions. Sie können die Anwendung zum Protokollieren von Informationen zur Ausnahme vor dem Standardhandler System die Ausnahme, die dem Benutzer meldet und die Anwendung beendet.It allows the application to log information about the exception before the system default handler reports the exception to the user and terminates the application. Wenn genügend Informationen über den Zustand der Anwendung sind möglicherweise verfügbare, andere Aktionen durchgeführt werden, z. B. Speichern von Daten aus dem Programm für eine spätere Wiederherstellung -.If sufficient information about the state of the application is available, other actions may be undertaken - such as saving program data for later recovery. Vorsicht ist empfehlenswert, da Daten aus dem Programm beschädigt werden können, wenn Ausnahmen nicht behandelt werden.Caution is advised, because program data can become corrupted when exceptions are not handled.

Hinweis

In der .NET Framework-Versionen 1.0 und 1.1 werden Beenden der Anwendung und Debuggen von Optionen für den Benutzer gemeldet, bevor dieses Ereignis ausgelöst wird, anstatt erst nach.In the .NET Framework versions 1.0 and 1.1, application termination and debugging options are reported to the user before this event is raised, rather than after.

Dieses Ereignis kann in jeder Anwendungsdomäne behandelt werden.This event can be handled in any application domain. Das Ereignis wird jedoch nicht unbedingt in der Anwendungsdomäne ausgelöst, in dem die Ausnahme aufgetreten ist.However, the event is not necessarily raised in the application domain where the exception occurred. Nur wenn der gesamte Stapel des Threads entladen wurde ohne Suchen nach einem entsprechenden Ausnahmehandler, daher ist der erste Ort, der das Ereignis ausgelöst werden kann in der Anwendungsdomäne, von dem der Thread stammt, wird eine Ausnahme nicht behandelt.An exception is unhandled only if the entire stack for the thread has been unwound without finding an applicable exception handler, so the first place the event can be raised is in the application domain where the thread originated.

Hinweis

Tritt auf, dieses Ereignis nur für die Standardanwendungsdomäne, die vom System erstellt wird, wenn eine Anwendung gestartet wird, in der .NET Framework-Versionen 1.0 und 1.1.In the .NET Framework versions 1.0 and 1.1, this event occurs only for the default application domain that is created by the system when an application is started. Wenn eine Anwendung zusätzliche Anwendungsdomänen erstellt, hat die gibt dabei einen Delegaten für dieses Ereignis in diesen Anwendungsdomänen keine Auswirkungen.If an application creates additional application domains, specifying a delegate for this event in those applications domains has no effect.

Wenn die UnhandledException Ereignis in der Standardanwendungsdomäne behandelt werden, es wird dann gibt es für alle in jedem Thread aus, unabhängig davon, welche die Anwendungsdomäne den Schritte im Thread nicht behandelte Ausnahme ausgelöst.If the UnhandledException event is handled in the default application domain, it is raised there for any unhandled exception in any thread, no matter what application domain the thread started in. Wenn der Thread in einer Anwendungsdomäne gestartet wird, die einen Ereignishandler für UnhandledException, das Ereignis wird ausgelöst, in dieser Anwendungsdomäne.If the thread started in an application domain that has an event handler for UnhandledException, the event is raised in that application domain. Wenn dieser Anwendungsdomäne nicht die Standardanwendungsdomäne ist, und es auch ein Ereignishandler in der Standardanwendungsdomäne gibt, wird das Ereignis in beide Anwendungsdomänen ausgelöst.If that application domain is not the default application domain, and there is also an event handler in the default application domain, the event is raised in both application domains.

Beispielsweise angenommen, ein Thread startet in Anwendungsdomäne "AD1", ruft eine Methode in der Anwendungsdomäne "AD2", und dort Ruft eine Methode in der Anwendungsdomäne "AD3", die, in dem eine Ausnahme ausgelöst.For example, suppose a thread starts in application domain "AD1", calls a method in application domain "AD2", and from there calls a method in application domain "AD3", where it throws an exception. Der ersten Anwendungsdomäne, in dem die UnhandledException -Ereignis ausgelöst werden kann, ist "AD1".The first application domain in which the UnhandledException event can be raised is "AD1". Wenn dieser Anwendungsdomäne nicht die Standardanwendungsdomäne ist, kann das Ereignis auch in der Standardanwendungsdomäne ausgelöst werden.If that application domain is not the default application domain, the event can also be raised in the default application domain.

Hinweis

Die common Language Runtime anhält, Threadabbrüche und Ereignishandler für die UnhandledException Ereignis ausgeführt werden.The common language runtime suspends thread aborts while event handlers for the UnhandledException event are executing.

Wenn der Ereignishandler verfügt über eine ReliabilityContractAttribute Attribut mit den geeigneten Flags, wird der Ereignishandler als einen eingeschränkten Ausführungsbereich behandelt.If the event handler has a ReliabilityContractAttribute attribute with the appropriate flags, the event handler is treated as a constrained execution region.

Beginnend mit der .NET Framework 4.NET Framework 4, dieses Ereignis wird nicht ausgelöst, für die Ausnahmen, die den Status des Prozesses beschädigt werden, wie z. B. Stapelüberläufe oder zugriffsverletzungen, es sei denn, der Ereignishandler sicherheitskritisch ist und verfügt über die HandleProcessCorruptedStateExceptionsAttribute Attribut.Starting with the .NET Framework 4.NET Framework 4, this event is not raised for exceptions that corrupt the state of the process, such as stack overflows or access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

In der .NET Framework-Versionen 1.0 und 1.1 eine nicht behandelte Ausnahme, die in einem anderen Thread als dem Hauptanwendungsthread auftritt, wird von der Laufzeit abgefangen und verursacht deshalb keine beenden die Anwendung.In the .NET Framework versions 1.0 and 1.1, an unhandled exception that occurs in a thread other than the main application thread is caught by the runtime and therefore does not cause the application to terminate. Daher ist es möglich, dass die UnhandledException Ereignis ausgelöst wurde ohne die Anwendung beendet.Thus, it is possible for the UnhandledException event to be raised without the application terminating. Ab .NET Framework, Version 2.0, wurde diese Sicherheitsnetz für nicht behandelte Ausnahmen in Threads, die untergeordnete entfernt werden, da es sich bei der kumulative Effekt einer automatischen Fehler enthielt eine Verringerung der Leistung, beschädigte Daten und Abstürze, die schwer zu wurden, das Debuggen.Starting with the .NET Framework version 2.0, this backstop for unhandled exceptions in child threads was removed, because the cumulative effect of such silent failures included performance degradation, corrupted data, and lockups, all of which were difficult to debug. Weitere Informationen einschließlich einer Liste von Fällen, in dem die Common Language Runtime nicht beendet wird, finden Sie unter Ausnahmen in verwalteten Threads.For more information, including a list of cases in which the runtime does not terminate, see Exceptions in Managed Threads.

Um einen Ereignishandler für dieses Ereignis zu registrieren, benötigen Sie die erforderlichen Berechtigungen, oder ein SecurityException ausgelöst.To register an event handler for this event, you must have the required permissions, or a SecurityException is thrown.

Weitere Informationen zur Behandlung von Ereignissen finden Sie unter behandeln und Auslösen von Ereignissen.For more information about handling events, see Handling and Raising Events.

Andere Ereignisse für nicht behandelte AusnahmenOther Events for Unhandled Exceptions

Für bestimmte Anwendungsmodelle der UnhandledException Ereignis kann mit anderen Ereignissen getrennt werden, wenn die nicht behandelte Ausnahme im Thread hauptanwendung auftritt.For certain application models, the UnhandledException event can be preempted by other events if the unhandled exception occurs in the main application thread.

Nicht behandelte Ausnahmen in die Hauptassembly der Anwendung Thread Ursache, in Anwendungen, die Windows Forms verwendet, die Application.ThreadException Ereignis ausgelöst wurde.In applications that use Windows Forms, unhandled exceptions in the main application thread cause the Application.ThreadException event to be raised. Wenn dieses Ereignis behandelt wird, ist das Standardverhalten, dass es sich bei die Anwendung nicht in die nicht behandelte Ausnahme beendet wird, auch wenn die Anwendung in einem unbekannten Zustand gelassen wird.If this event is handled, the default behavior is that the unhandled exception does not terminate the application, although the application is left in an unknown state. In diesem Fall die UnhandledException Ereignis wird nicht ausgelöst.In that case, the UnhandledException event is not raised. Dieses Verhalten kann geändert werden, mithilfe der Anwendungskonfigurationsdatei oder mit der Application.SetUnhandledExceptionMode Methode zum Ändern des websitemodus, UnhandledExceptionMode.ThrowException vor der ThreadException Ereignishandler verknüpft ist.This behavior can be changed by using the application configuration file, or by using the Application.SetUnhandledExceptionMode method to change the mode to UnhandledExceptionMode.ThrowException before the ThreadException event handler is hooked up. Dies gilt nur für den Thread der hauptanwendung.This applies only to the main application thread. Die UnhandledException Ereignis wird ausgelöst, für nicht behandelte Ausnahmen in anderen Threads.The UnhandledException event is raised for unhandled exceptions thrown in other threads.

Ab Microsoft Visual Studio 2005 stellt das Anwendungsframework für die Visual Basic ein anderes Ereignis für unbehandelte Ausnahmen in Thread der hauptanwendung bereit.Starting with Microsoft Visual Studio 2005, the Visual Basic application framework provides another event for unhandled exceptions in the main application thread. Finden Sie unter den WindowsFormsApplicationBase.UnhandledException Ereignis.See the WindowsFormsApplicationBase.UnhandledException event. Dieses Ereignis verfügt über ein Ereignisobjekt für die Argumente mit den gleichen Namen wie das Ereignisargumentobjekt, der von verwendeten AppDomain.UnhandledException, jedoch mit unterschiedlichen Eigenschaften.This event has an event arguments object with the same name as the event arguments object used by AppDomain.UnhandledException, but with different properties. Insbesondere diese Ereignisargumentobjekt ein ExitApplication -Eigenschaft, die der Anwendung ermöglicht, weiterhin ausgeführt wird, die nicht behandelte Ausnahme wird ignoriert (und verlässt Sie die Anwendung in einem unbekannten Zustand).In particular, this event arguments object has an ExitApplication property that allows the application to continue running, ignoring the unhandled exception (and leaving the application in an unknown state). In diesem Fall die AppDomain.UnhandledException Ereignis wird nicht ausgelöst.In that case, the AppDomain.UnhandledException event is not raised.

Sicherheit

SecurityCriticalAttribute
erfordert volle Vertrauenswürdigkeit für den unmittelbaren Aufrufer.requires full trust for the immediate caller. Dieser Member kann nicht von teilweise vertrauenswürdigem oder transparentem Code verwendet werden.This member cannot be used by partially trusted or transparent code.

Gilt für: